<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <!-- <div class="widget-numbers text-success text-right" *ngIf="folio && folio.hfolio">
        <span>{{ total | currency: 'MXN' }}</span>
        <span class="ml-2" style="font-size: 1.5rem;">{{ myFormGroup.value.hmon }}</span>
    </div> -->
    <button class="btn btn-success" [disabled]="myFormGroup.invalid || total === 0" (click)="guardarForm()"
        *ngIf="ajuste !== 'S'">
        <i class="fas fa-save mr-2"></i>Guardar
    </button>
</app-page-title>

<div class="card animated fadeIn">
    <div class="card-body">
        <div class="row" style="display: inline;" *ngIf="folio && folio.hfolio">
            <!-- <ng-container *ngIf="!flagAjuste && codigoSelected">
                <span class="badge badge-success mr-2" [ngClass]="{ 'text-danger': flagCargoInv }"
                    *ngIf="!flagCancelarMovto && codigoSelected.cdc === 'C'">
                    Abono <p *ngIf="flagCargoInv">Invertido</p>
                </span>
                <span class="badge badge-danger" *ngIf="flagCancelarMovto">CXLD</span>
                <span class="badge badge-warning" [ngClass]="{ 'text-danger': flagCargoInv }"
                    *ngIf="!flagCancelarMovto && codigoSelected.cdc === 'D'">
                    Cargo <p *ngIf="flagCargoInv">Invertido</p>
                </span>
                <span *ngIf="codigoTrans">
                    Transacción: <strong>{{ codigoTrans }}</strong>
                </span>
            </ng-container> -->
            Folio
            <strong class="text-primary"> #{{ folio.hfolio }}</strong>
            <span class="text-muted ml-2">
                <i class="fas fa-user mr-2"></i>
                <strong>{{ nombreHuesped }}</strong>
            </span>
        </div>
        <div class="divider"></div>

        <form [formGroup]="myFormGroup" *ngIf="!flagSplit">
            <div class="row">
                <ng-container *ngIf="!flagAjuste">
                    <div class="form-group col-6 col-sm-4 col-md-3 col-lg-2 col-xl-2" *ngIf="!checkout">
                        <label for="cuarto">Cuarto</label>
                        <div class="input-group">
                            <input type="text" class="form-control" name="cuarto" maxlength="7" pattern="[0-9]*"
                                #idCuarto (change)="valueChangeCuarto(idCuarto.value)" [(ngModel)]="folio.cuarto"
                                [readOnly]="checkout" tabindex="1" [ngModelOptions]="{standalone: true}" appFocus>
                            <span class="input-group-append">
                                <button class="btn btn-info" (click)="openModal(modalHuesped, 'xl')">
                                    <i class="fa fa-search"></i>
                                </button>
                            </span>
                        </div>
                    </div>
                    <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-1">
                        <label for="hthfolio">Cuenta</label>
                        <input type="text" class="form-control" formControlName="htfolio">
                    </div>
                    <div class="form-group col-sm-6 col-md-6 col-lg-4 col-xl-4">
                        <label>Código</label>
                        <ng-container *ngIf="!flagAjuste && codigoSelected">
                            <span class="badge badge-success ml-2" [ngClass]="{ 'text-danger': flagCargoInv }"
                                *ngIf="!flagCancelarMovto && codigoSelected.cdc === 'C'">
                                Abono <p *ngIf="flagCargoInv">Invertido</p>
                            </span>
                            <span class="badge badge-warning ml-2" [ngClass]="{ 'text-danger': flagCargoInv }"
                                *ngIf="!flagCancelarMovto && codigoSelected.cdc === 'D'">
                                Cargo <p *ngIf="flagCargoInv">Invertido</p>
                            </span>
                            <span class="ml-2" *ngIf="codigoTrans">
                                Transacción: <strong>{{ codigoTrans }}</strong>
                            </span>
                        </ng-container>
                        <kendo-combobox [data]="dsCodigos" formControlName="codigo"
                            (valueChange)="onChangeCodigo($event)" [textField]="'cdesc'" [valueField]="'Codigo'"
                            [filterable]="true" (filterChange)="handleFilter($event)" [readonly]="flagAjuste"
                            [valuePrimitive]="true" tabindex="3" class="form-control" #idCodigo>
                        </kendo-combobox>
                    </div>
                    <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
                        <label for="hvoucher">Voucher</label>
                        <span class="badge badge-danger ml-2"
                            *ngIf="myFormGroup.value.hvoucher && flagCancelarMovto">CXLD</span>
                        <kendo-autocomplete [data]="dsVouchers" [(value)]="myFormGroup.value.hvoucher"
                            [readonly]="!myFormGroup.value.codigo || flagAjuste" (valueChange)="changeVoucher();"
                            formControlName="hvoucher" tabindex="4" class="form-control">
                        </kendo-autocomplete>
                    </div>
                    <div class="form-group col">
                        <label>Número Tarjeta</label>
                        <input type="text" tabindex="5" class="form-control" formControlName="dfp"
                            [readonly]="codigoSelected && codigoSelected.cfp !== '2'">
                    </div>

                    <div class="row col-12 d-flex justify-content-between">
                        <div class="row-fluid col-sm-4 col-md-4 col-lg-3 col-xl-3">
                            <div class="form-group">
                                <label>Subtotal</label>
                                <kendo-numerictextbox formControlName="hsubtotal" tabindex="6" max="9999999" min="0"
                                    class="form-control">
                                </kendo-numerictextbox>
                            </div>
                            <div class="form-group">
                                <label>Servicio</label>
                                <kendo-numerictextbox formControlName="hprop"
                                    [readonly]="codigoSelected && codigoSelected.cdesg || codigoSelected && !codigoSelected.cprop"
                                    tabindex="7" max="9999999" min="0" class="form-control">
                                </kendo-numerictextbox>
                            </div>
                            <div class="form-group">
                                <label for="total">Total</label>
                                <kendo-numerictextbox [(ngModel)]="total" formControlName="iInte5" [readonly]="'true'"
                                    name="total" max="9999999" min="0" class="form-control">
                                </kendo-numerictextbox>
                            </div>
                        </div>
                        <div class="row-fluid col-sm-8 col-md-8 col-lg-7 col-xl-7">
                            <div class="row">
                                <div class="form-group col-sm-8 col-lg-8">
                                    <label>Moneda</label>
                                    <kendo-combobox [data]="dsMonedas" formControlName="hmon"
                                        (valueChange)="getTipoCambio($event);" [textField]="'mdesc'"
                                        [valueField]="'Moneda'" [valuePrimitive]="true"
                                        [readonly]="codigoSelected && !codigoSelected.cmoneda" class="form-control">
                                    </kendo-combobox>
                                </div>
                                <div class="form-group col-sm-4 col-lg-4">
                                    <label for="htc">Tipo Cambio</label>
                                    <kendo-numerictextbox formControlName="htc" [readonly]="'true'"
                                        class="form-control">
                                    </kendo-numerictextbox>
                                </div>
                            </div>
                            <ng-container *ngIf="!flagAjuste">
                                <div class="form-group">
                                    <label for="hnotas">Notas</label>
                                    <textarea class="form-control" formControlName="hnotas" rows="2"
                                        tabindex="8"></textarea>
                                </div>
                                <ng-container *ngIf="manttoCaja[3]">
                                    <div class="form-group"
                                        *ngIf="!flagCancelarMovto && codigoSelected && codigoSelected.cdc === 'D'">
                                        <button class="btn btn-danger btn-block"
                                            (click)="flagCargoInv = !flagCargoInv;">
                                            Cargo en Rojo
                                        </button>
                                    </div>
                                </ng-container>
                                <ng-container *ngIf="manttoCaja[5]">
                                    <div class="form-group"
                                        *ngIf="!flagCancelarMovto && codigoSelected && codigoSelected.cdc === 'C'">
                                        <button class="btn btn-dark btn-block" (click)="flagCargoInv = !flagCargoInv;">
                                            FP en Negro
                                        </button>
                                    </div>
                                </ng-container>
                            </ng-container>
                        </div>
                        <div class="row-fluid col-2" *ngIf="flagAjuste">
                            <div class="form-group">
                                <label for="hvoucher">Voucher</label>
                                <kendo-autocomplete [data]="dsVouchers" [readonly]="'true'" formControlName="hvoucher"
                                    class="form-control">
                                </kendo-autocomplete>
                            </div>
                        </div>
                    </div>
                </ng-container>
                <!--    AJUTE DE MOVIMIENTO   -->
                <div class="row" id="idAjuste" *ngIf="flagAjuste">
                    <div class="form-group col-12 text-center">
                        <h5>Ajuste de Movimiento</h5>
                    </div>
                    <!-- Subtotal -->
                    <div class="form-group row col-md-12 col-lg-6 col-xl-6">
                        <label for="hsubtotal" class="col-4 col-form-label">Sub-Total</label>
                        <div class="col-6">
                            <kendo-numerictextbox formControlName="hsubtotal" (change)="cambioSubtotal()"
                                class="form-control"></kendo-numerictextbox>
                        </div>
                    </div>
                    <!-- Servicio -->
                    <div class="form-group row col-md-12 col-lg-6 col-xl-6">
                        <label for="hprop" class="col-4 col-form-label">Servicio</label>
                        <div class="col-6">
                            <kendo-numerictextbox
                                [readonly]="codigoSelected && codigoSelected.cdesg || codigoSelected && !codigoSelected.cprop"
                                formControlName="hprop" class="form-control" (change)="cambioSubtotal()">
                            </kendo-numerictextbox>
                        </div>
                    </div>
                    <!-- Total Ajuste -->
                    <div class="form-group row col-md-12 col-lg-6 col-xl-6">
                        <label for="montoAjuste" class="col-4 col-form-label">Total Ajuste</label>
                        <div class="col-6">
                            <kendo-numerictextbox [(ngModel)]="montoAjuste" [ngModelOptions]="{standalone: true}"
                                class="form-control" [readonly]="'true'">
                            </kendo-numerictextbox>
                        </div>
                    </div>
                    <!-- Nuevo Total -->
                    <div class="form-group row col-md-12 col-lg-6 col-xl-6">
                        <label for="totalAjuste" class="col-4 col-form-label">Nuevo Total</label>
                        <div class="col-6">
                            <kendo-numerictextbox [(ngModel)]="totalAjuste" [ngModelOptions]="{standalone: true}"
                                [readonly]="'true'" class="form-control">
                            </kendo-numerictextbox>
                        </div>
                    </div>
                    <!-- Notas -->
                    <div class="form-group col-12">
                        <label for="hnotas">Notas</label>
                        <textarea class="form-control" formControlName="hnotas" rows="2"></textarea>
                    </div>
                </div>
                <!--  -->
            </div>
        </form>

        <!--    SEPARAR MOVIMIENTOS   -->
        <div class="row d-flex justify-content-center" id="idSplit" *ngIf="flagSplit">
            <div class="m-2">
                <h4>Separar Movimiento</h4>
            </div>
            <div class="row col-11">
                <!-- Fecha -->
                <div class="form-group col-md-3 col-lg-3 col-xl-2">
                    <label for="tfecha">Fecha</label>
                    <div class="form-group">
                        <input type="text" class="form-control" name="tfecha" [(ngModel)]="movtoAjuste.tfecha" readonly>
                    </div>
                </div>
                <!-- Codigo -->
                <div class="form-group col-md-5 col-lg-4 col-xl-3">
                    <label for="tcod">Código</label>
                    <kendo-combobox [data]="dsCodigos" [(ngModel)]="movtoAjuste.tcod" [textField]="'cdesc'"
                        [valueField]="'Codigo'" [readonly]="'true'" [valuePrimitive]="true" name="codigo"
                        class="form-control">
                    </kendo-combobox>
                </div>
                <!-- Voucher del movimiento -->
                <div class="form-group col-md-3 col-lg-3 col-xl-2">
                    <label for="tvouc">Voucher</label>
                    <div class="form-group">
                        <input type="text" class="form-control" name="tvouc" [(ngModel)]="movtoAjuste.tvouc" readonly>
                    </div>
                </div>
                <!-- Moneda -->
                <div class="form-group col-md-3 col-lg-3 col-xl-3">
                    <label for="Moneda">Moneda</label>
                    <kendo-combobox [data]="dsMonedas" [(ngModel)]="movtoAjuste.Moneda" [textField]="'mdesc'"
                        [valueField]="'Moneda'" [readonly]="'true'" [valuePrimitive]="true" name="Moneda"
                        class="form-control">
                    </kendo-combobox>
                </div>
                <!-- Tipo de Cambio -->
                <div class="form-group col-md-3 col-lg-3 col-xl-2">
                    <label for="ttcamb">T.C.</label>
                    <kendo-numerictextbox [(ngModel)]="movtoAjuste.ttcamb" [readonly]="'true'" name="ttcamb"
                        class="form-control">
                    </kendo-numerictextbox>
                </div>
                <div class="form-group col-md-5 col-lg-4 col-xl-2">
                    <label for="hsubtotal">Sub-Total</label>
                    <kendo-numerictextbox [(ngModel)]="movtoAjuste.tabono" [readonly]="'true'" name="hsubtotal"
                        class="form-control" *ngIf="movtoAjuste.tabono">
                    </kendo-numerictextbox>
                    <kendo-numerictextbox [(ngModel)]="movtoAjuste.tcargo" [disabled]="'true'" name="hsubtotal"
                        class="form-control" *ngIf="movtoAjuste.tcargo">
                    </kendo-numerictextbox>
                </div>
                <div class="form-group col-md-5 col-lg-4 col-xl-2">
                    <label for="hprop">Servicio</label>
                    <kendo-numerictextbox [(ngModel)]="myFormGroup.value.hprop" [disabled]="'true'" name="hprop"
                        class="form-control">
                    </kendo-numerictextbox>
                </div>
                <div class="form-group col-md-5 col-lg-4 col-xl-2">
                    <label for="totalAjuste">Total</label>
                    <kendo-numerictextbox [(ngModel)]="totalAjuste" name="totalAjuste" [disabled]="'true'"
                        class="form-control">
                    </kendo-numerictextbox>
                </div>
            </div>
            <div class="col-3">
                <div class="form-group text-center col-12">
                    <h5>Tipo</h5>
                    <button class="btn btn-block py-2 m-1"
                        (click)="tipoSplit = 'Porcentaje'; desglosarPorciones(porciones);"
                        [ngClass]="{'btn-primary': tipoSplit === 'Porcentaje', 'btn-dark': tipoSplit !== 'Porcentaje'}">
                        Porcentaje
                    </button>
                    <button class="btn btn-block py-2 m-1" (click)="tipoSplit = 'Monto'; desglosarPorciones(porciones);"
                        [ngClass]="{'btn-primary': tipoSplit === 'Monto','btn-dark': tipoSplit !== 'Monto'}">Monto
                    </button>
                    <button class="btn btn-success py-2 px-4 mt-3" (click)="generarSplit()">
                        <i class="fa fa-check mr-2"></i>Aceptar
                    </button>
                </div>
            </div>
            <div class="col-6">
                <div class="form-group text-center col-12">
                    <h5>Separar en {{ tipoSplit }}</h5>
                    <ng-container *ngFor="let item of totalPorciones; let index = index;">
                        <button class="btn col-2 my-3 py-2 m-1" (click)="desglosarPorciones(item + 2)"
                            [ngClass]="{'btn-warning': (item + 2) !== porciones, 'btn-primary': (item + 2) === porciones}">{{
                            item + 2 }}
                        </button>
                    </ng-container>
                    <div class="row">
                        <div id="confirmar-porciones" class="container col" *ngIf="desglosePorciones">
                            <div class="row d-flex justify-content-center">
                                <div class="col-12">
                                    <h6>Subtotal</h6>
                                </div>
                                <ng-container *ngFor="let item of arrayPorciones; let index = index;">
                                    <kendo-numerictextbox class="w-100 col-4" [(ngModel)]="item"
                                        (blur)="onChangePorciones(item, index)">
                                    </kendo-numerictextbox>
                                </ng-container>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<ng-template #modalAuth let-c="close" let-d="dismiss">
    <div class="modal-header">
        Autorización
    </div>
    <div class="modal-body">
        <app-authorization (user)="userAuth($event); c('Close click');"></app-authorization>
    </div>
</ng-template>

<ng-template #modalPack let-c="close" let-modal let-d="dismiss">
    <div class="modal-header" *ngIf="movtoAjuste.ttHuespaq.length">
        <h6 class="modal-title">Paquetes {{ movtoAjuste.ttHuespaq[0].paquete }}</h6>
        <button class="close" aria-label="Close" (click)="closePaquetes(movtoAjuste.ttHuespaq, modal.dismiss)">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <table class="table table-hover text-center">
            <thead>
                <tr>
                    <td scope="col">Código</td>
                    <td scope="col" class="text-right">Monto</td>
                    <td scope="col">Ajustar</td>
                </tr>
            </thead>
            <tbody>
                <tr *ngFor="let movto of movtoAjuste.ttHuespaq">
                    <td scope="col">{{ movto.codigo }}</td>
                    <td scope="col" class="text-right">{{ movto.hmonto | number: '.2-3' }}</td>
                    <td scope="col">
                        <kendo-switch name="hsel" [(ngModel)]="movto.hsel" [onLabel]="'Si'" [offLabel]="'No'">
                        </kendo-switch>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
    <div class="modal-footer">
        <button class="btn btn-primary" (click)="closePaquetes(movtoAjuste.ttHuespaq, c)">Continuar</button>
    </div>
</ng-template>

<ng-template #modalHuesped let-c="close" let-d="dismiss">
    <div class="modal-header">

        <h6 class="modal-title">Huespedes en Casa</h6>
        <button class="close" aria-label="Close" (click)="c()">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <app-buscar [ttfolio]="dataFolios" (resultFolio)="resultHuesped($event); c();"></app-buscar>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c()">Cerrar</button>
    </div>
</ng-template>

<div id="recibo" #recibo style="display: none;" *ngIf="codigoSelected">
    <div style="text-align: left;">
        {{ ttInfocia.crsocial }} <br>
        {{ ttInfocia.edireccion1 }} {{ ttInfocia.eexterior }} <br>
        {{ ttInfocia.edireccion2 }} <br>
        {{ ttInfocia.eciudad }}, {{ ttInfocia.eEstado }}, {{ ttInfocia.ecp }}<br>
        R.F.C.: {{ ttInfocia.rfc }}<br>
    </div>
    <br>
    <div style="text-align: center;">RECIBO</div>
    <table style="width:100%;text-align:left;margin-top:15px; border: solid 1px black;">
        <tr>
            <td>Fecha: {{ ttInfocia.fday }} {{ myFormGroup.value.hhora }}</td>
            <td>Ope: {{ ttUsuario.cUserId }}</td>
        </tr>
        <tr>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td> {{ nombreHuesped }} </td>
        </tr>
        <tr>
            <td># Folio {{ folio.hfolio }}</td>
            <td>Entrada: {{ folio.hfent }}</td>
        </tr>
        <tr>
            <td>Cuarto: {{ folio.cuarto }} </td>
            <td>Salida: {{ folio.hfsal }}</td>
        </tr>
        <tr>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td>{{ codigoSelected.cdesc }}</td>
        </tr>
        <tr>
            <td>Voucher: {{ myFormGroup.value.hvoucher }}</td>
            <td>Monto: {{ total | number: '.2-2' }}
                <span *ngIf="codigoSelected && codigoSelected.cdc === 'C'">-</span>
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
        </tr>
        <tr style="text-align: center;">
            <td>{{ totalFormatText }}</td>
        </tr>
    </table>
</div>